import { FALSE, Json, PropertySpecs, Spec, TRUE } from "./types";
declare function parse<T extends Spec>(json: string, spec: T): Json<T>;
export declare const j: {
    nullable: {
        optional: {
            string: {
                target: "string";
                nullable: TRUE;
                optional: TRUE;
            };
            number: {
                target: "number";
                nullable: TRUE;
                optional: TRUE;
            };
            boolean: {
                target: "boolean";
                nullable: TRUE;
                optional: TRUE;
            };
            unknown: {
                target: "unknown";
                nullable: TRUE;
                optional: TRUE;
            };
            object: <T extends PropertySpecs>(propertySpecs: T) => {
                target: "object";
                entries: T;
                nullable: TRUE;
                optional: TRUE;
            };
            array: <T_1 extends Spec>(itemSpec: T_1) => {
                target: "array";
                element: T_1;
                nullable: TRUE;
                optional: TRUE;
            };
        };
        string: {
            target: "string";
            nullable: TRUE;
            optional: FALSE;
        };
        number: {
            target: "number";
            nullable: TRUE;
            optional: FALSE;
        };
        boolean: {
            target: "boolean";
            nullable: TRUE;
            optional: FALSE;
        };
        unknown: {
            target: "unknown";
            nullable: TRUE;
            optional: FALSE;
        };
        object: <T_2 extends PropertySpecs>(propertySpecs: T_2) => {
            target: "object";
            entries: T_2;
            nullable: TRUE;
            optional: FALSE;
        };
        array: <T_3 extends Spec>(itemSpec: T_3) => {
            target: "array";
            element: T_3;
            nullable: TRUE;
            optional: FALSE;
        };
    };
    optional: {
        nullable: {
            string: {
                target: "string";
                nullable: TRUE;
                optional: TRUE;
            };
            number: {
                target: "number";
                nullable: TRUE;
                optional: TRUE;
            };
            boolean: {
                target: "boolean";
                nullable: TRUE;
                optional: TRUE;
            };
            unknown: {
                target: "unknown";
                nullable: TRUE;
                optional: TRUE;
            };
            object: <T extends PropertySpecs>(propertySpecs: T) => {
                target: "object";
                entries: T;
                nullable: TRUE;
                optional: TRUE;
            };
            array: <T_1 extends Spec>(itemSpec: T_1) => {
                target: "array";
                element: T_1;
                nullable: TRUE;
                optional: TRUE;
            };
        };
        string: {
            target: "string";
            nullable: FALSE;
            optional: TRUE;
        };
        number: {
            target: "number";
            nullable: FALSE;
            optional: TRUE;
        };
        boolean: {
            target: "boolean";
            nullable: FALSE;
            optional: TRUE;
        };
        unknown: {
            target: "unknown";
            nullable: FALSE;
            optional: TRUE;
        };
        object: <T_4 extends PropertySpecs>(propertySpecs: T_4) => {
            target: "object";
            entries: T_4;
            nullable: FALSE;
            optional: TRUE;
        };
        array: <T_5 extends Spec>(itemSpec: T_5) => {
            target: "array";
            element: T_5;
            nullable: FALSE;
            optional: TRUE;
        };
    };
    parse: typeof parse;
    parser: <T_6 extends Spec>(spec: T_6) => {
        parse: (json: string) => Json<T_6>;
    };
    string: {
        target: "string";
        nullable: FALSE;
        optional: FALSE;
    };
    number: {
        target: "number";
        nullable: FALSE;
        optional: FALSE;
    };
    boolean: {
        target: "boolean";
        nullable: FALSE;
        optional: FALSE;
    };
    unknown: {
        target: "unknown";
        nullable: FALSE;
        optional: FALSE;
    };
    object: <T_7 extends PropertySpecs>(propertySpecs: T_7) => {
        target: "object";
        entries: T_7;
        nullable: FALSE;
        optional: FALSE;
    };
    array: <T_8 extends Spec>(itemSpec: T_8) => {
        target: "array";
        element: T_8;
        nullable: FALSE;
        optional: FALSE;
    };
};
export {};
