"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.j = void 0;
var validators_1 = require("./validators");
var t = { value: true };
var f = { value: false };
var normal = {
    string: { target: "string", nullable: f, optional: f },
    number: { target: "number", nullable: f, optional: f },
    boolean: { target: "boolean", nullable: f, optional: f },
    unknown: { target: "unknown", nullable: f, optional: f },
    object: function (propertySpecs) { return ({
        target: "object",
        entries: propertySpecs,
        nullable: f,
        optional: f,
    }); },
    array: function (itemSpec) { return ({
        target: "array",
        element: itemSpec,
        nullable: f,
        optional: f,
    }); },
};
var nullable = {
    string: { target: "string", nullable: t, optional: f },
    number: { target: "number", nullable: t, optional: f },
    boolean: { target: "boolean", nullable: t, optional: f },
    unknown: { target: "unknown", nullable: t, optional: f },
    object: function (propertySpecs) { return ({
        target: "object",
        entries: propertySpecs,
        nullable: t,
        optional: f,
    }); },
    array: function (itemSpec) { return ({
        target: "array",
        element: itemSpec,
        nullable: t,
        optional: f,
    }); },
};
var optional = {
    string: { target: "string", nullable: f, optional: t },
    number: { target: "number", nullable: f, optional: t },
    boolean: { target: "boolean", nullable: f, optional: t },
    unknown: { target: "unknown", nullable: f, optional: t },
    object: function (propertySpecs) { return ({
        target: "object",
        entries: propertySpecs,
        nullable: f,
        optional: t,
    }); },
    array: function (itemSpec) { return ({
        target: "array",
        element: itemSpec,
        nullable: f,
        optional: t,
    }); },
};
var loose = {
    string: { target: "string", nullable: t, optional: t },
    number: { target: "number", nullable: t, optional: t },
    boolean: { target: "boolean", nullable: t, optional: t },
    unknown: { target: "unknown", nullable: t, optional: t },
    object: function (propertySpecs) { return ({
        target: "object",
        entries: propertySpecs,
        nullable: t,
        optional: t,
    }); },
    array: function (itemSpec) { return ({
        target: "array",
        element: itemSpec,
        nullable: t,
        optional: t,
    }); },
};
function parse(json, spec) {
    var obj = JSON.parse(json);
    validators_1.validate("", obj, spec);
    return obj;
}
exports.j = __assign(__assign({}, normal), { nullable: __assign(__assign({}, nullable), { optional: loose }), optional: __assign(__assign({}, optional), { nullable: loose }), parse: parse, parser: function (spec) { return ({
        parse: function (json) { return parse(json, spec); },
    }); } });
//# sourceMappingURL=j.js.map