import { ArraySpec, BooleanSpec, NumberSpec, ObjectSpec, Spec, StringSpec, UnknownSpec } from "./specs";
export interface SpecProvider {
    string: StringSpec;
    number: NumberSpec;
    boolean: BooleanSpec;
    unknown: UnknownSpec;
    array(itemSpec: Spec): ArraySpec;
    object<T extends {
        [key: string]: Spec;
    }>(propertySpecs: T): ObjectSpec;
}
export interface RootSpecProvider extends SpecProvider {
    nullable: OptionalSpecProvider;
    optional: NullableSpecProvider;
}
export interface OptionalSpecProvider extends SpecProvider {
    optional: SpecProvider;
}
export interface NullableSpecProvider extends SpecProvider {
    nullable: SpecProvider;
}
export declare function specProvider(nullable: boolean, optional: boolean): SpecProvider;
